### MP Fénelon Sainte-Marie --- Informatique
### Chapitre 6 --- Encore des tris
##############################################################################

import random
import time
import matplotlib.pyplot as plt

#print("**********************************************")
#print("***************** Tri bulle ******************")
#print("**********************************************")

def Echange(L,i1,i2):
    x=L[i1]
    L[i1]=L[i2]
    L[i2]=x

def TriBulle(L):
    n=len(L)
    for i in range(0,n-1):
        for j in range(n-1,i,-1):
            if L[j]<L[j-1]:
                Echange(L,j,j-1)
    return L

#print("**********************************************")
#print("***************** Tri rapide *****************")
#print("**********************************************")

def Partition(L,g,d):

    if g<d:
        x=L[g]
        pivot=g
        for i in range(g+1,d):
            if L[i]<x:
                pivot=pivot+1
                if i!=pivot:
                    Echange(L,i,pivot)
        if pivot!=g:
            Echange(L,g,pivot) # on met le pivot à sa place
        return pivot

def TriRapide(L,g,d):
    if g>=d-1:
        return
    k=Partition(L,g,d)
    TriRapide(L,g,k)
    TriRapide(L,k+1,d)

#print("**********************************************")
#print("***************** Tri Fusion *****************")
#print("**********************************************")

def TriFusion(L,gauche,droite):
    if gauche<droite:
        milieu = (gauche+droite)//2
        TriFusion(L,gauche,milieu)
        TriFusion(L,milieu+1,droite)
        Interclassement(L,gauche,milieu,droite)

def Interclassement(L,g,m,d):
# on interclasse les sous-parties L[g:milieu] et L[milieu:d]
# contigües de la liste L

    longueur=d-g+1 # longueur de L[g:d]
    T=['MP' for i in range(0,longueur)] # paquet temporaire ds lequel on fusionne
    i=g
    j=m+1
    for k in range(0,longueur):
        #im=i<=m
        if i<=m and j<=d: # fusion des paquets, quand les deux sont non vides
            if L[i]<L[j]: # on pioche dans le premier paquet
                T[k]=L[i]
                i=i+1
            else:         # on pioche dans le second paquet
                T[k]=L[j]
                j=j+1
        else:             # un des paquets est vide !
            if i<=m:      # le premier paquet est non vide, on pioche dedans
                T[k]=L[i]
                i=i+1
            else:         # le second paquet est non vide, on pioche dedans
                T[k]=L[j]
                j=j+1
    for k in range(0,longueur): # enfin on remplit L[g:d] avec les élts de T
        L[g+k]=T[k]
        

# Tests basiques
#L=[6,3,0,9,1,7,8,2,5,4]
#print("L avant :",L)
#TriFusion(L,0,len(L)-1)
#print("L après :",L)

"""
taille= 1000
maximum=10000000
L1=[random.randrange(maximum) for i in range(taille)]
L2=list(L1)
L3=list(L1)

print("liste comportant",taille,"éléments choisis entre 1 et",maximum)
#print("Liste avant TriBulle :")
#print(L1)

#temps=time.time()
#TriBulle(L1)
#print("Liste après TriBulle :")
#print(L1)
#print("temps pour TriBulle",time.time()-temps)

#print("Liste avant TriRapide :")
#print(L2)
temps=time.time()
TriRapide(L2,0,len(L2))
#print("Liste après TriRapide :")
#print(L2)
print("temps pour TriRapide",time.time()-temps)

#print("Liste avant TriFusion :")
#print(L3)
temps=time.time()
TriFusion(L3,0,len(L3)-1)
#print("Liste après TriFusion :")
#print(L3)
print("temps pour TriFusion",time.time()-temps)
"""

maximum=10000
NbTests = 10
NbExperiences = 10
X = []
Yrapide = []
Yfusion = []
TempsTotal = time.time()
for k in range(1,NbExperiences+1):
    taille = maximum * k // NbExperiences
    print("étape",k,":",NbTests,"tests pour des listes à",taille,"éléments")
    X.append(taille)
    tempsRapide = 0
    tempsFusion = 0
    for i in range(NbTests):
        L1 = [random.randrange(maximum) for i in range(taille)]
        L2 = list(L1)
        L3 = list(L1)
        t = time.time()
        TriRapide(L2,0,len(L1))
        tempsRapide = tempsRapide + time.time() - t
        
        t = time.time()
        TriFusion(L3,0,len(L1)-1)
        tempsFusion = tempsFusion + time.time() - t
    tempsMoyRapide = tempsRapide / NbTests
    tempsMoyFusion = tempsFusion / NbTests
    Yrapide.append(tempsMoyRapide)
    Yfusion.append(tempsMoyFusion)

print("Temps total :",time.time()-TempsTotal)
plt.clf()
plt.plot(X,Yrapide,'r')
plt.plot(X,Yfusion,'g')
plt.show()